/*
 * Copyright (C) 2002 by Call Direct Cellular Solutions Pty. Ltd. All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. All advertising materials mentioning features or use of this
 *    software must display the following acknowledgement:
 *
 *    This product includes software developed by Call Direct Cellular Solutions Pty. Ltd.
 *    and its contributors.
 *
 * THIS SOFTWARE IS PROVIDED BY CALL DIRECT CELLULAR SOLUTIONS AND CONTRIBUTORS
 * ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
 * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL CALL DIRECT
 * CELLULAR SOLUTIONS OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS
 * OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED
 * AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
 * OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
 * THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 * For additional information see http://www.calldirect.com.au/
 *
 * -
 * Copyright (C) 2001-2002 by egnite Software GmbH. All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. All advertising materials mentioning features or use of this
 *    software must display the following acknowledgement:
 *
 *    This product includes software developed by egnite Software GmbH
 *    and its contributors.
 *
 * THIS SOFTWARE IS PROVIDED BY EGNITE SOFTWARE GMBH AND CONTRIBUTORS
 * ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
 * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL EGNITE
 * SOFTWARE GMBH OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS
 * OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED
 * AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
 * OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
 * THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 * For additional information see http://www.ethernut.de/
 *
 * -
 * Portions Copyright (C) 2000 David J. Hudson <dave@humbug.demon.co.uk>
 *
 * This file is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE.
 *
 * You can redistribute this file and/or modify it under the terms of the GNU
 * General Public License (GPL) as published by the Free Software Foundation;
 * either version 2 of the License, or (at your discretion) any later version.
 * See the accompanying file "copying-gpl.txt" for more details.
 *
 * As a special exception to the GPL, permission is granted for additional
 * uses of the text contained in this file.  See the accompanying file
 * "copying-liquorice.txt" for details.
 * -
 * Portions Copyright (c) 1983, 1993 by
 *	The Regents of the University of California.  All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. All advertising materials mentioning features or use of this software
 *    must display the following acknowledgement:
 *	This product includes software developed by the University of
 *	California, Berkeley and its contributors.
 * 4. Neither the name of the University nor the names of its contributors
 *    may be used to endorse or promote products derived from this software
 *    without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 * -
 * Portions Copyright (c) 1993 by Digital Equipment Corporation.
 *
 * Permission to use, copy, modify, and distribute this software for any
 * purpose with or without fee is hereby granted, provided that the above
 * copyright notice and this permission notice appear in all copies, and that
 * the name of Digital Equipment Corporation not be used in advertising or
 * publicity pertaining to distribution of the document or software without
 * specific, written prior permission.
 * 
 * THE SOFTWARE IS PROVIDED "AS IS" AND DIGITAL EQUIPMENT CORP. DISCLAIMS ALL
 * WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING ALL IMPLIED WARRANTIES
 * OF MERCHANTABILITY AND FITNESS.   IN NO EVENT SHALL DIGITAL EQUIPMENT
 * CORPORATION BE LIABLE FOR ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL
 * DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR
 * PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS
 * ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS
 * SOFTWARE.
 */

/*
 * $Log: PPPif.c,v $
 * Revision 1.3  2002/11/02 15:15:13  harald
 * Library dependencies removed
 *
 * Revision 1.2  2002/10/31 16:05:40  harald
 * Enable ImageCraft compilation
 *
 * Revision 1.1  2002/10/29 12:44:54  harald
 * PPP support added
 *
 *
 * Revision 1.2  2002/10/17 MJC CDCS
 * Fixed multithreading race condition
 *
 * Revision 1.1  2002/09/18 MJC CDCS
 * Fixed framing bug
 *
 * Revision 1.0  2002/03/28 MJC CDCS
 * Created
 *
 */

/*
 * This driver  is stable for my configuration but will need work if it is going
 * to be generally useful, as such it is being released as a pre-alpha driver at this stage.
 *
 * Specific things that are known to be missing or need work are:-
 *	User Authentication
 *	Link state management (please discuss with me if you are planning to work on this)
 *	CRC should be table based
 *  DNS server update handling (Ethernut native reslover not presently supported)
 *  Outbound Async Character mapping should be improved
 *
 * Good Luck !!!
 *
 * This code is supplied by Mike Cornelius of Call Direct Cellular Solutions
 * you can contact me at mikec@calldirect.com.au
 *
*/

#include <string.h>

#include <sys/heap.h>
#include <sys/thread.h>
#include <sys/event.h>
#include <sys/timer.h>
#include <sys/ifstream.h>
#include <sys/print.h>      /* Formatted output functions. */

#include <net/PPPif.h>
#include <net/if_var.h>
#include <netinet/ip.h>

#include <dev/uartavr.h>
#include <dev/irqreg.h>

//#include "CDCS_CMUX.h"

//#define	USECMUX

char ppp_tx_bsy;
HANDLE ppp_tx_rdy;

#ifdef NUTDEBUG
#include <sys/kprint.h>
#include <sys/osdebug.h>
#include <net/netdebug.h>
#endif

//void PPPSetState (NUTDEVICE *dev, u_char state)
//{
//	PPPINFO		*ni;
//	ni = (PPPINFO *)dev->dev_dcb;
//	ni->ppp_state = state;
//}

// Make it look like we've lost DCD
void PPPTerminateSesion (NUTDEVICE *dev)
{
	IFNET			*ifn;
	PPPINFO			*ni;

#ifdef USECMUX
    CMUXDCB			*dcb;
#else
	UARTDCB			*dcb;
#endif
	

	ni = (PPPINFO *)dev->dev_dcb;
	ifn = (IFNET *)dev->dev_icb;
	dcb = ifn->if_host_dev->dev_dcb;

	ni->ppp_state = DEAD;
	//dcb->dcb_ctrlLines &= ~V24_DV;
}


u_char PPPGetState (NUTDEVICE *dev)
{
	PPPINFO		*ni;
	ni = (PPPINFO *)dev->dev_dcb;
	return ni->ppp_state;
}

void PPPStateTimerCallback(HANDLE timer, void *dev)
{
	PPPINFO		*ni;
	ni = (PPPINFO *)((NUTDEVICE *)dev)->dev_dcb;

	if (ni->ppp_state == LINK_UP)
	{
		if (ni->ppp_retry++ < 3)
		{
			// Start the timer again
			NutTimerStart(15000, PPPStateTimerCallback, dev, TM_ONESHOT);
			PPPLCPRequestOptions(dev);		// Start the ball rolling
			return;
		}
	}
	
	if (ni->ppp_state != PPP_UP)
	{
		ni->ppp_state = DEAD;
		NutEventPostAsync(&ni->ppp_state_chg);
	}
}

unsigned int PPP_Calc_CRC(unsigned int c) 
{
    char i;                 // Just a loop index
    c &= 0xFF;              // Only calculate CRC on low byte
    for (i=0;i<8;i++)       // Loop eight times, once for each bit
    {                       
        if (c&1)            // Is bit high?
        {                   
            c /= 2;         // Position for next bit
            c ^= 0x8408;    // Toggle the feedback bits
        } 
        else c /= 2;        // Just position for next bit
    }                       // This routine would be best optimized in assembly
    return c;               // Return the 16 bit checksum
}

void PPPAsyncMapOut(NUTDEVICE *dev, u_char *p, u_short len)
{

	u_char		obuff[130];
	u_char		i,n;
	PPPINFO		*ni;
	IFNET		*ifn;

	ni = (PPPINFO *)dev->dev_dcb;
	ifn = (IFNET *)dev->dev_icb;

	n = 0;

	while (n < len)
	{
		// Send 128 byte chunks
		for (i = 0; i < 128;)
		{
			if (((ni->ppp_useACFC) == 0) ||
				((ni->ppp_state & AUTH_UP) == 0))
			{
				if ((*p) < 0x20)
				{
					obuff[i++] = 0x7D;
					obuff[i] = (*p) ^0x20;
				}
				else if ((*p) == 0x7E)
				{
					obuff[i++] = 0x7D;
					obuff[i] = (*p) ^0x20;
				}
				else if ((*p) == 0x7D)
				{
					obuff[i++] = 0x7D;
					obuff[i] = (*p) ^0x20;
				}
				else
				{
					obuff[i] = (*p);
				}
			}
			else if ((*p) == 0x0D)
			{
				obuff[i++] = 0x7D;
				obuff[i] = (*p) ^0x20;
			}
			else if ((*p) == 0x0A)
			{
				obuff[i++] = 0x7D;
				obuff[i] = (*p) ^0x20;
			}
			else if ((*p) == 0x7D)
			{
				obuff[i++] = 0x7D;
				obuff[i] = (*p) ^0x20;
			}
			else if ((*p) == 0x7E)
			{
				obuff[i++] = 0x7D;
				obuff[i] = (*p) ^0x20;
			}
			else
			{
				obuff[i] = (*p);
			}
			p++;
			n++;
			i++;
			if (n == len) 
				break;
		}

		NutIfStreamWrite(ifn->if_host_dev, obuff, i);
		NutIfStreamFlush(ifn->if_host_dev);
	}
	

	return;
}


/*!
 * \brief Actually send a PPP packet
 *
 * \param nb Network buffer structure containing the packet to be sent.
 *           The structure must have been allocated by a previous
 *           call NutNetBufAlloc(). This routine will automatically
 *           release the buffer in case of an error.
 *
 * \return 0 on success, -1 in case of any errors. Errors
 *         will automatically release the network buffer 
 *         structure.
 */
static int PPPPutPacket(NUTDEVICE *dev, NETBUF *nb)
{
    u_short sz;
	u_short CSum;
    u_short i;
	u_char	flag = 0x7E;
    u_char *p;

	IFNET		*ifn;
	PPPINFO		*ni;

	ni = (PPPINFO *)dev->dev_dcb;
	ifn = (IFNET *)dev->dev_icb;

	ppp_tx_bsy = 1;

    //
    // Calculate the number of bytes to be send. Do not
    // send packets larger than 1536 bytes.
    //
    sz = nb->nb_dl.sz + nb->nb_nw.sz + nb->nb_tp.sz + nb->nb_ap.sz;
    if(sz >= ni->ppp_mru)
	{
        NutNetBufFree(nb);
        return -1;
    }

#ifdef NUTDEBUG
    if(ppp_trace > 1)
        NutPrintFormat(dev_debug, "[PPPTX-%u]\r\n", sz);
#endif

	// Calculate checksum
	CSum = 0xFFFF;
	p = nb->nb_dl.vp;
    for(i = 0; i < nb->nb_dl.sz; i++)
		CSum = PPP_Calc_CRC((*p++)^CSum) ^ (CSum/256); 

    p = nb->nb_nw.vp;
    for(i = 0; i < nb->nb_nw.sz; i++)
       CSum = PPP_Calc_CRC((*p++)^CSum) ^ (CSum/256); 

    p = nb->nb_tp.vp;
    for(i = 0; i < nb->nb_tp.sz; i++)
       CSum = PPP_Calc_CRC((*p++)^CSum) ^ (CSum/256); 

    p = nb->nb_ap.vp;
    for(i = 0; i < nb->nb_ap.sz; i++)
       CSum = PPP_Calc_CRC((*p++)^CSum) ^ (CSum/256); 

	NutIfStreamWrite(ifn->if_host_dev, &flag, 1);

	PPPAsyncMapOut(dev, nb->nb_dl.vp, nb->nb_dl.sz);
	PPPAsyncMapOut(dev, nb->nb_nw.vp, nb->nb_nw.sz);
	PPPAsyncMapOut(dev, nb->nb_tp.vp, nb->nb_tp.sz);
	PPPAsyncMapOut(dev, nb->nb_ap.vp, nb->nb_ap.sz);


	CSum = ~CSum;
	//NutKPrintFormat("[PPPTX-CSUM %x]\r\n", CSum);
	PPPAsyncMapOut(dev, (u_char *)&CSum, 2);
	NutIfStreamWrite(ifn->if_host_dev, &flag, 1);
	NutIfStreamFlush(ifn->if_host_dev);
	
	// Let any other threads that are waiting to send PPP packets know it's OK to do so
	ppp_tx_bsy = 0;
	NutEventBroadcastAsync(&ppp_tx_rdy);

    return 0;
}



int NutPPPOutput(NUTDEVICE *dev, u_short type, NETBUF *nb)
{

    PPPHDR *ph;
    IFNET *nif;

	//NutKPrintString("Enter NutPPPOutput\r\n");

    if(NutNetBufAlloc(nb, NBAF_DATALINK, sizeof(PPPHDR)) == 0)
        return -1;

	//NutKPrintFormat("NutPPPOutput - nb = %x ph = %x\r\n", nb, nb->nb_dl.vp);

    ph = (PPPHDR *)nb->nb_dl.vp;
	ph->address = 0xFF;
	ph->control = 0x03;
    ph->prot_type = htons(type);

	nif = dev->dev_icb;
    return (*nif->if_send)(dev, nb);
}

void PPP_SetDefaultOptions(NUTDEVICE *dev)
{
	PPPINFO		*ni;
	ni = (PPPINFO *)dev->dev_dcb;

	ni->ppp_usePFC	= 0;
	ni->ppp_useACFC = 0;
	ni->ppp_auth	= 0;
	ni->ppp_magic	= 0;
	ni->ppp_accm	= 0xFFFFFFFF;
	ni->ppp_mru		= 1500;
	ni->ppp_state	= DEAD;
}

u_char * XCP_CopyOption(u_char *o , u_char *p)
{
    memcpy (o,p,*(p+1));
	return o + *(p+1);
}

void PPPLCPRequestOptions(NUTDEVICE *dev)
{
	LCPHDR		*lcpo;
	NETBUF		*nbo;
	u_char		*o;
	PPPINFO		*ni;

	ni = (PPPINFO *)dev->dev_dcb;

	nbo = NutNetBufAlloc(0, NBAF_NETWORK, 10);
	lcpo = nbo->nb_nw.vp;
	lcpo->code = XCP_CR;								// CODE = Request
	lcpo->id = ni->ppp_lcp_id ++;						// ID = ??
	o = (u_char *)(lcpo+1);

	// 1st Option = ACCM
	*o++ = LCP_ACCM;
	*o++ = 0x06;
	*o++ = 0x00;
	*o++ = 0x00;
	*o++ = 0x00;
	*o++ = 0x00;

	nbo->nb_nw.sz = ((int)o - (int)nbo->nb_nw.vp);	// Set Size
	lcpo->len = htons(nbo->nb_nw.sz);

	if (NutPPPOutput(dev, PROT_LCP, nbo) == 0)
		NutNetBufFree(nbo);
}

void NutLCPInput(NUTDEVICE *dev, NETBUF *nb)
{
	LCPHDR		*lcp;
	LCPHDR		*lcpo;
	NETBUF		*nbo;
	PPPINFO		*ni;
	u_char		bad_options;
	int			i;
	u_char		*p;
	u_char		*o;

    ni = (PPPINFO *)dev->dev_dcb;

#ifdef NUTDEBUG
    if(ppp_trace)
		NutPrintString_P(dev_debug, PSTR("Enter LCP\r\n"));
#endif

	// Extract LCP header
	lcp = (LCPHDR *)nb->nb_nw.vp;
	lcp->len = ntohs(lcp->len);

	switch (lcp->code)
	{
	case XCP_CR:
		ni->ppp_accm	= 0;       // Reset Local options 
        ni->ppp_usePFC	= 0;
        ni->ppp_useACFC	= 0;
       
        bad_options = 0;
        
		// Create a buffer to hold our response 
		// Our response can be no bigger that the request so lets start there
		// Fill in the header with the exception of the "code"
		// Set the initial length to the length of the header
		// Set "o" output pointer to the start of the data part
		nbo = NutNetBufAlloc(0, NBAF_NETWORK, lcp->len);
		lcpo = nbo->nb_nw.vp;
		lcpo->id = lcp->id;
		lcpo->len = htons(sizeof(lcpo)); 
		o = (u_char *)(lcpo+1);				

        if (lcp->len > 4)	// If options sent 
        {
			p = (u_char *)(lcp+1);		// Set pointer to first option
            do                                            
            {				
                switch (*p)
                {
				case LCP_MRU:
					i = (*(p+1))-2;
					memcpy (&(ni->ppp_mru), p+2, i);
					ni->ppp_mru = ntohs(ni->ppp_mru);
#ifdef NUTDEBUG
					if(ppp_trace)
						NutPrintFormat(dev_debug, "MRU = %x \r\n", ni->ppp_mru);
#endif
                    break;
                case LCP_ACCM:
					i = (*(p+1))-2;
					memcpy (&(ni->ppp_accm), p+2, i);
#ifdef NUTDEBUG
					if(ppp_trace)
					NutPrintFormat(dev_debug, "ACCM = %lx\r\n", ni->ppp_accm);
#endif
                    break;
				case LCP_AUTH:
					i = (*(p+1))-2;
					memcpy (&(ni->ppp_auth), p+2, i);
					ni->ppp_auth = ntohs(ni->ppp_auth);
#ifdef NUTDEBUG
					if(ppp_trace)
					NutPrintFormat(dev_debug, "AUTH = %x\r\n", ni->ppp_auth);
#endif
                    break;
                case LCP_PFC:
#ifdef NUTDEBUG
					if(ppp_trace)
						NutPrintString_P(dev_debug, PSTR("PFC =1\r\n"));
#endif
                    ni->ppp_usePFC = 1;
                    break;
                case LCP_ACFC:
#ifdef NUTDEBUG
					if(ppp_trace)
						NutPrintString_P(dev_debug, PSTR("ACFC =1\r\n"));
#endif
                    ni->ppp_useACFC = 1;
                    break;
                default:
#ifdef NUTDEBUG
					if(ppp_trace)
					NutPrintFormat(dev_debug, "Bad Option %x\r\n", *p);
#endif
                    o =  XCP_CopyOption (o,p);       // Save the bad option
                    bad_options ++;
                    break;
                }

				p += *(p+1);	// Next option = this option + length of this option
            }
            while (p < (((u_char *)lcp) + lcp->len));		// Iterate through all options in packet
        }

        if (bad_options == 0)								// MMMM Goood options
        {	
			memcpy (nbo->nb_nw.vp, nb->nb_nw.vp, nb->nb_nw.sz); // Copy entire packet
            lcpo->code = XCP_CA; 							// Chnage the result code
			lcpo->len = htons(nbo->nb_nw.sz);				// Set Size
			if (NutPPPOutput(dev, PROT_LCP, nbo) == 0)
				NutNetBufFree(nbo);

			// OK we've accpeted thier options lets send ours
			//NutLCPRequestOptions(dev)
        }
        else												// Bleuch Bad options
        {
			PPP_SetDefaultOptions(dev);						// Reset all options if we reject any
			lcpo->code = XCP_CRJ; 							// Set the reslut code
			nbo->nb_nw.sz = ((int)o - (int)nbo->nb_nw.vp);	// Set Size
			lcpo->len = htons(nbo->nb_nw.sz);	
	
			if (NutPPPOutput(dev, PROT_LCP, nbo) == 0)
				NutNetBufFree(nbo);
        }
		break;

	case XCP_CA:
#ifdef NUTDEBUG
		if(ppp_trace)
			NutPrintString_P(dev_debug, PSTR("LCP Options Negotiated\r\n"));
#endif
		ni->ppp_state |= LCP_UP;

		// OK All options negotiated lets Authenticate
		nbo = NutNetBufAlloc(0, NBAF_NETWORK, 6);
		lcpo = nbo->nb_nw.vp;
		lcpo->code = PAP_REQ;								// CODE = Request
		lcpo->id = ni->ppp_lcp_id++;						// ID = ??
		o = (u_char *)(lcpo+1);

		// User
		*o++ = 0x00;

		// Pass
		*o++ = 0x00;
			
		nbo->nb_nw.sz = ((int)o - (int)nbo->nb_nw.vp);	// Set Size
		lcpo->len = htons(nbo->nb_nw.sz);

		if (NutPPPOutput(dev, PROT_PAP, nbo) == 0)
			NutNetBufFree(nbo);
		break;
	}

	NutNetBufFree(nb);
}

void NutIPCPInput(NUTDEVICE *dev, NETBUF *nb)
{
	LCPHDR		*ipcp;	// Same format different data
	LCPHDR		*ipcpo;
	NETBUF		*nbo;
	PPPINFO		*ni;
	IFNET		*ifn;
	u_char		bad_options;
	int			i;
	u_char		*p;
	u_char		*o;

	ifn = dev->dev_icb;
    ni = (PPPINFO *)dev->dev_dcb;

#ifdef NUTDEBUG
    if(ppp_trace)
		NutPrintString_P(dev_debug, PSTR("Enter IPCP\r\n"));
#endif

	// Extract IPCP header
	ipcp = (LCPHDR *)nb->nb_nw.vp;
	ipcp->len = ntohs(ipcp->len);

	// Create a buffer to hold our response 
	// Our response can be no bigger that the request so lets start there
	// Fill in the header with the exception of the "code"
	// Set the initial length to the length of the header
	// Set "o" output pointer to the start of the data part
	nbo = NutNetBufAlloc(0, NBAF_NETWORK, ipcp->len);
	ipcpo = nbo->nb_nw.vp;
	ipcpo->id = ipcp->id;
	ipcpo->len = htons(sizeof(ipcpo)); 
	o = (u_char *)(ipcpo+1);	

	switch (ipcp->code)
	{
	case XCP_CA:
#ifdef NUTDEBUG
		if(ppp_trace)
			NutPrintString_P(dev_debug, PSTR("IPCP Accept\r\n"));
#endif

		if (ipcp->len > 4)	// If options sent 
        {
			p = (u_char *)(ipcp+1);		// Set pointer to first option
            do                                            
            {
				//NutKPrintFormat("&ipcp = %x &opt = %x\r\n", ipcp, p);
				
                switch (*p)
                {
				case IPCP_ADDRESS:
					i = (*(p+1))-2;
					memcpy (&(ifn->if_local_ip), p+2, i);
					//NutPrintString_P(dev_debug, PSTR("Local IP = %lx \r\n"), ifn->if_local_ip);
                    break;
				case IPCP_PRI_DNS:
					i = (*(p+1))-2;
					memcpy (&(ifn->if_pdns), p+2, i);
					//NutPrintString_P(dev_debug, PSTR("Primary DNS = %lx \r\n"), ifn->if_pdns);
                    break;
				case IPCP_SEC_DNS:
					i = (*(p+1))-2;
					memcpy (&(ifn->if_sdns), p+2, i);
					//NutPrintString_P(dev_debug, PSTR("Primary DNS = %lx \r\n"), ifn->if_sdns);
                    break;
				default:
					break;
                }

				p += *(p+1);	// Next option = this option + length of this option
            }
            while (p < (((u_char *)ipcp) + ipcp->len));		// Iterate through all options in packet
			//NutEventPostAsync(&ni->ppp_state_chg);
		}
#ifdef NUTDEBUG
		if(ppp_trace)
			NutPrintString_P(dev_debug, PSTR("PPP State = UP\r\n"));
#endif
		ni->ppp_state = PPP_UP;
		NutEventPostAsync(&ni->ppp_state_chg);
		break;

	case XCP_CN:
#ifdef NUTDEBUG
		if(ppp_trace)
			NutPrintString_P(dev_debug, PSTR("IPCP Nack\r\n"));
#endif
		if (ipcp->len > 4)										// If options sent 
        {		
			memcpy (nbo->nb_nw.vp, nb->nb_nw.vp, nb->nb_nw.sz); // Copy entire packet
            ipcpo->code = XCP_CR; 								// Chnage the result code
			ipcpo->id++;										// Increment ID
			ipcpo->len = htons(nbo->nb_nw.sz);					// Set Size
			if (NutPPPOutput(dev, PROT_IPCP, nbo) == 0)
				NutNetBufFree(nbo);
		}
		break;


	case XCP_CR:
#ifdef NUTDEBUG
		if(ppp_trace)
			NutPrintString_P(dev_debug, PSTR("IPCP Request\r\n"));
#endif
		bad_options = 0;
		if (ipcp->len > 4)	// If options sent 
        {
			p = (u_char *)(ipcp+1);		// Set pointer to first option
            do                                            
            {
			    switch (*p)
                {
				case IPCP_ADDRESS:
					i = (*(p+1))-2;
					memcpy (&(ifn->if_remote_ip), p+2, i);
					//NutPrintString_P(dev_debug, PSTR("Remote IP = %lx \r\n"), ifn->if_remote_ip);
                    break;
				default:
#ifdef NUTDEBUG
					NutPrintFormat(dev_debug, "Bad Option %x\r\n", *p);
#endif
                    o =  XCP_CopyOption (o,p);       // Save the bad option
					//NutPrintString_P(dev_debug, PSTR("&ipcp = %x &opt = %x\r\n"), ipcp, p);
                    bad_options ++;
                    break;
                }

				p += *(p+1);	// Next option = this option + length of this option
            }
            while (p < (((u_char *)ipcp) + ipcp->len));		// Iterate through all options in packet
        }

        if (bad_options == 0)								// MMMM Goood options
        {
			memcpy (nbo->nb_nw.vp, nb->nb_nw.vp, nb->nb_nw.sz); // Copy entire packet
            ipcpo->code = XCP_CA; 							// Chnage the result code
			ipcpo->len = htons(nbo->nb_nw.sz);				// Set Size
			if (NutPPPOutput(dev, PROT_IPCP, nbo) == 0)
				NutNetBufFree(nbo);
		}
		else												// Bleuch Bad options
        {
		}
		break;

	case XCP_CRJ:
#ifdef NUTDEBUG
		if(ppp_trace)
			NutPrintString_P(dev_debug, PSTR("IPCP Reject\r\n"));
#endif
		if (ipcp->len > 4)	// If options sent 
        {
			p = (u_char *)(ipcp+1);		// Set pointer to first option
            do                                            
            {
				//NutPrintString_P(dev_debug, PSTR("opt = %x\r\n"), *p);
				p += *(p+1);	// Next option = this option + length of this option
            }
            while (p < (((u_char *)ipcp) + ipcp->len));		// Iterate through all options in packet
        }
		ni->ppp_state = DEAD;
		NutEventPostAsync(&ni->ppp_state_chg);
		break;
	}

	NutNetBufFree(nb);
}

void NutPAPInput(NUTDEVICE *dev, NETBUF *nb)
{
	LCPHDR		*pap;		// Same format different data
	LCPHDR		*papo;
	NETBUF		*nbo;
	PPPINFO		*ni;
	u_char		*o;

    ni = (PPPINFO *)dev->dev_dcb;

#ifdef NUTDEBUG
	if(ppp_trace)
		NutPrintString_P(dev_debug, PSTR("Enter PAP\r\n"));
#endif

	// Extract PAP header
	pap = (LCPHDR *)nb->nb_nw.vp;
	pap->len = ntohs(pap->len);

	if (pap->code == PAP_ACK)
	{
#ifdef NUTDEBUG
		if(ppp_trace)
			NutPrintString_P(dev_debug, PSTR("PAP ACK \r\n"));
#endif
		ni->ppp_state |= AUTH_UP;

		// OK Authenticated lets get IP up 
		nbo = NutNetBufAlloc(0, NBAF_NETWORK, 24);
		papo = nbo->nb_nw.vp;
		papo->code = PAP_REQ;								// CODE = Request
		papo->id = ni->ppp_lcp_id++;						// ID = ??
		o = (u_char *)(papo+1);

		
		// 1st Option = My ADDRESS
		*o++ = IPCP_ADDRESS;
		*o++ = 0x06;
		*o++ = 0x00;
		*o++ = 0x00;
		*o++ = 0x00;
		*o++ = 0x00;

		// 2nd Option = Primary DNS
		*o++ = IPCP_PRI_DNS;
		*o++ = 0x06;
		*o++ = 0x00;
		*o++ = 0x00;
		*o++ = 0x00;
		*o++ = 0x00;

		// 3rd Option = Secondary DNS
		*o++ = IPCP_SEC_DNS;
		*o++ = 0x06;
		*o++ = 0x00;
		*o++ = 0x00;
		*o++ = 0x00;
		*o++ = 0x00;
		
			
		nbo->nb_nw.sz = ((int)o - (int)nbo->nb_nw.vp);	// Set Size
		papo->len = htons(nbo->nb_nw.sz);

		if (NutPPPOutput(dev, PROT_IPCP, nbo) == 0)
			NutNetBufFree(nbo);
	}

	NutNetBufFree(nb);

}

/*!
 * \brief Handle incoming PPP frames.
 *
 * Splits the frame into the data link and the
 * network part. Then the frame is routed to the proper
 * handler, based on the type field in the PPP header.
 *
  *
 * \note This routine is called by the device driver on
 *       incoming PPP packets. Applications typically do
 *       not call this function.
 *
 * \param dev Identifies the device that received the frame.
 * \param nd  Netbuf containing the frame.
 */
void PPPInput(NUTDEVICE *dev, NETBUF *nb)
{

	u_short prot_type;

    //
    // Split the PPP frame.
	// Ignore the address and control bytes and extract the protocol...
    //
    memcpy (&prot_type, ((u_char *)nb->nb_dl.vp) + 2, 2);
    nb->nb_nw.vp = ((u_char *)nb->nb_dl.vp) + 4;
    nb->nb_nw.sz = nb->nb_dl.sz - 4;
    nb->nb_dl.sz = 4;

	//NutPrintString_P(dev_debug, PSTR("Enter PPPInput prot = %x\r\n"), ntohs(prot_type));
    //
    // Route frame to the correct handler.
    //
    switch(ntohs(prot_type))
	{
    case PROT_IP:
        NutIpInput(dev, nb);
        break;
    case PROT_LCP:
        NutLCPInput(dev, nb);
        break;
	case PROT_IPCP:
        NutIPCPInput(dev, nb);
        break;
	case PROT_PAP:
        NutPAPInput(dev, nb);
        break;
    default:
        NutNetBufFree(nb);
        break;
    }
}

/*! \fn PPPRx(void *arg)
 * \brief PPP receiver thread.
 *
 * 
 * It runs with high priority.
 */

THREAD(PPPRx, arg)
{
    NUTDEVICE		*dev;
    IFNET			*ifn;
    PPPINFO			*ni;
    NETBUF			*nb;
	u_char			*PPPRxBuff;
	u_char			inbuf[1];
	int				i;
	char			esc;
	unsigned int    CSum;

    dev = arg;
    ifn = (IFNET *)dev->dev_icb;
    ni = (PPPINFO *)dev->dev_dcb;

#ifdef NUTDEBUG
    if(ppp_trace)
        NutPrintString_P(dev_debug, PSTR("Enter PPPReceive \r\n"));
#endif

	if ((PPPRxBuff = NutHeapAlloc(PPP_MRU)) == NULL)
	{
#ifdef NUTDEBUG
		NutPrintString_P(dev_debug, PSTR("\r\nFatal Error: Cannot Allocate PPP receive bufefr \r\n"));
#endif
		while (1) NutSleep(1000);
	}
	
    NutThreadSetPriority(18);
    for(;;) 
	{
		
		// If not in use 
		//ni->if_host_dev == NULL;
		if (ni->ppp_state == DEAD)	
		{
			NutSleep(100);
			continue;
		}
		
		/*
		// If no longer connected (IE DCD Not active)
		dcb = ifn->if_host_dev->dev_dcb;
		if ((dcb->dcb_ctrlLines & V24_DV) == 0)
		{
			if (ni->ppp_state == PPP_UP)
			{
				//if ((dcb->dcb_ctrlLines & V24_DV) == 0)
				//{
				//ifn->if_host_dev = NULL;
					//PPP_SetDefaultOptions(dev);
					//NutEventPostAsync(&ni->ppp_state_chg);
				ni->ppp_state = DEAD;
#ifdef NUTDEBUG
					if(ppp_trace)
						NutKPrintString_P(PSTR("PPP Session closed\r\n"));
#endif
				continue;
				//}
			}
		}*/


		// Start off by waiting for a flag byte 
		if ((NutDeviceRead(ifn->if_host_dev, inbuf, 1) == 0) ||
				(inbuf [0] != HDLC_FLAG))
			continue;

		// Absorb any extra flags that may appear (particularly if we miss a packet)
		// And place the first byte of the packet in inbuf [0]
		while (inbuf [0] == HDLC_FLAG)
		{
			NutDeviceRead(ifn->if_host_dev, inbuf, 1);
		}
		
		esc = 0;
		CSum = 0xFFFF;
	
		// Ok we've got a flag now lets get the rest of the packet
		for (i = 0; i < PPP_MRU; i ++)
		{
			if (inbuf [0] == HDLC_FLAG)
			{
				// Complete packet received
				//NutPrintFormat_P (dev_debug, PSTR("PPPRX2 s=%d c=%x ifn=%x dev = %x\r\n"), i, CSum, ifn, dev);
				//NutPrintFlush(dev_debug);
				if (CSum == FCS_GOOD)
				{
					i -= 2; // Don't copy FCS 	
					nb = NutNetBufAlloc(0, NBAF_DATALINK, i);
					if (nb)
					{	
						memcpy (nb->nb_dl.vp,PPPRxBuff,i);
						ni->ppp_rx_packets++;
						(*ifn->if_recv)(dev, nb);
					}
				}
				else
				{
					ni->ppp_rx_crc_errors ++;
				}

				break;
			}
			else if (inbuf [0] == HDLC_ESCAPE)
			{
				esc = 1;
				i --;
			}
			else
			{	
				PPPRxBuff[i] = inbuf [0];
				if (esc)
				{
					PPPRxBuff[i] ^= 0x20;
					esc = 0;
				}
				CSum = PPP_Calc_CRC(PPPRxBuff[i]^CSum) ^ (CSum/256); // Calculate CRC
			}
			// Get the next byte
			while (NutDeviceRead(ifn->if_host_dev, inbuf, 1) == 0);
		}       
    }
}

/*!
 * \brief Send PPP packet.
 *
 * \param dev   Identifies the device to use.
 * \param nb    Network buffer structure containing the packet to be sent.
 *              The structure must have been allocated by a previous
 *              call NutNetBufAlloc(). This buffer will be automatically
 *              released in case of an error.
 * \param flags Set to 1 for asynchronous output, 0 otherwise.
 *
 * \return 0 on success, -1 in case of any errors. Errors
 *         will automatically release the network buffer 
 *         structure.
 */

int PPPOutput(NUTDEVICE *dev, NETBUF *nb)
{
    int			rc = -1;
    PPPINFO		*ni;
	IFNET		*ifn;
#ifdef USECMUX
    CMUXDCB			*h_dcb;
#else
	UARTDCB			*h_dcb;
#endif

    ni = (PPPINFO *)dev->dev_dcb;
	ifn = (IFNET *)dev->dev_icb;

#ifdef NUTDEBUG
    if(ppp_trace > 1)
        NutPrintString_P(dev_debug, PSTR("Enter PPPOutput\r\n"));
#endif
	
	h_dcb = ifn->if_host_dev->dev_dcb;

	//while (ppp_tx_bsy == 1)
	//{
	//	NutThreadYield();
	//}
	if (ppp_tx_bsy == 1) 
		NutEventWait(&ppp_tx_rdy,0);

	if((rc = PPPPutPacket(dev, nb)) == 0)
		ni->ppp_tx_packets++;
    
    return rc;
}

/*!
 * \brief Initialize PPP Interface.
 *
 * The uart that this PPP handler is connected to is passed in 
 * the MAC part of the ICB.
 *
 * Applications typically do not use this function, but
 * call NutNetIfConfig().
 *
 * \param dev Identifies the device to initialize. The
 *            structure must be properly set.
 */
int PPPInit(NUTDEVICE *dev)
{
    IFNET		*ifn;
	PPPINFO		*ni;


#ifdef NUTDEBUG
    if(ppp_trace)
        NutPrintString_P(dev_debug, PSTR("Enter PPPInit\r\n"));
#endif

	ppp_tx_bsy = 0;
	
	ifn = dev->dev_icb;
	ni = (PPPINFO *)dev->dev_dcb;

	memset(ni, 0, sizeof(PPPINFO));
	PPP_SetDefaultOptions(dev);

	//
	// Set the state to LINK_UP 
	// We shouldn't be here unless the application has established a link
	// when ppp_state == DEAD the PPP receiver thread does not handle packets
	// Otherwise it does 
	ni->ppp_state = LINK_UP;
	NutSleep(200);

	// Start the PPP state timer
	NutTimerStart(15000, PPPStateTimerCallback, dev, TM_ONESHOT);

	PPPLCPRequestOptions(dev);		// Start the ball rolling

	if (GetThreadByName("ppprx") == NULL)
		ni->ppp_rx_thread = NutThreadCreate("ppprx", PPPRx, dev, 512);

    return 0;
}

int CDNetPPPConnect (NUTDEVICE *dev, CONST char *scriptin)
{
	char script[128];
	char response[128];
	char *t;
	char *u;
	char *s;
	char *resend;
	int got,i,retry;
	u_long	to;

	IFSTREAM *ifs;
	ifs = (IFSTREAM *)dev->dev_icb;

	// Check length
	if (strlen (scriptin) > 127) return -1;
	strcpy(script, (char *)scriptin);
	
	// Setup read timeout
	to = 5000;//1500;
	//to = 0;
	NutDeviceIOCtl(dev, UART_SETREADTIMEOUT, &to);

	// Discard receive buffer
	NutIfStreamRead(dev, 0, 0);

	retry = 0;
	s = script;
	resend = s;
	while ((t = strchr(s,':')))
	{
		// Command 
		*t = 0;
		NutPrintFormat(dev, "%s\r\n", s);
		i = NutIfStreamFlush(dev);

		s = t+1;
		
		// Response
		u = strchr(s,':');
		*u = 0;
		do
		{
			got = NutDeviceGetLine(dev, response, sizeof (response) -1);
			if (got == -1)
			{
				// Timeout
				*t = ':';		// Put back the delimiters
				*u = ':';
				u = resend-1;	// Restore command pointer
				retry ++;		// Only try 5 times
				if (retry == 5)
					return -1;
#ifdef NUTDEBUG
				if(ppp_trace)
				{
					NutPrintFormat(dev_debug, "Timeout retrying\r\n");
					NutPrintFlush(dev_debug);
				}
#endif
				break;
			}
			else
			{
				response[got] = 0;
				i = strncmp (response,s,strlen(s));
#ifdef NUTDEBUG
				if(ppp_trace)
				{
					NutPrintFormat(dev_debug, "s = %s r = %s g = %d i = %d\r\n", s, response, got, i);
					NutPrintFlush(dev_debug);
				}
#endif
			}
		}
		while (i!=0);

		s = u+1;
		resend = s;
		//break;
	}
	// Setup read timeout
	//to = 1500;
	to = 0;
	NutDeviceIOCtl(dev, UART_SETREADTIMEOUT, &to);
	return 0;
}

/*@}*/
