#ifndef _DEV_PPPif_H_
#define _DEV_PPPif_H_

/*
 * Copyright (C) 2002 by Call Direct Cellular Solutions Pty. Ltd. All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. All advertising materials mentioning features or use of this
 *    software must display the following acknowledgement:
 *
 *    This product includes software developed by Call Direct Cellular Solutions Pty. Ltd
 *    and its contributors.
 *
 * THIS SOFTWARE IS PROVIDED BY CALL DIRECT CELLULAR SOLUTIONS AND CONTRIBUTORS
 * ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
 * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL CALL DIRECT
 * CELLULAR SOLUTIONS OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS
 * OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED
 * AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
 * OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
 * THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 * For additional information see http://www.calldirect.com.au/
 *
 * -
 * Portions Copyright (C) 2001 by egnite Software GmbH. All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. All advertising materials mentioning features or use of this
 *    software must display the following acknowledgement:
 *
 *    This product includes software developed by egnite Software GmbH
 *    and its contributors.
 *
 * THIS SOFTWARE IS PROVIDED BY EGNITE SOFTWARE GMBH AND CONTRIBUTORS
 * ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
 * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL EGNITE
 * SOFTWARE GMBH OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS
 * OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED
 * AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
 * OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
 * THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 * For additional information see http://www.ethernut.de/
 *
 * -
 * Portions Copyright (C) 2000 David J. Hudson <dave@humbug.demon.co.uk>
 *
 * This file is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE.
 *
 * You can redistribute this file and/or modify it under the terms of the GNU
 * General Public License (GPL) as published by the Free Software Foundation;
 * either version 2 of the License, or (at your discretion) any later version.
 * See the accompanying file "copying-gpl.txt" for more details.
 *
 * As a special exception to the GPL, permission is granted for additional
 * uses of the text contained in this file.  See the accompanying file
 * "copying-liquorice.txt" for details.
 */

/*
 * $Log: PPPif.h,v $
 * Revision 1.1  2002/11/02 15:17:42  harald
 * First check in
 *
 *
 * Revision 1.0  2002/03/28 MJC CDCS
 * New device structure implemented
 *
 */

#include <dev/netbuf.h>
#include <net/if_var.h>

/*!
 * \file dev/PPPif.h
 * \brief PPP Network interface definitions.
 */

/*!
 * \brief PPP Network interface information type.
 */
//typedef struct _PPPINFO PPPINFO;

/*!
 * \struct _PPPINFO PPPif.h dev/PPPif.h
 * \brief Network interface controller information structure.
 */
typedef struct _PPPINFO {
//    volatile u_char ppp_rx_cnt;		/*!< # of packets in NIC buffer. */
    //u_char ppp_tx_bsy;					/*!< PPP transmitter busy flags. */
//    HANDLE ppp_rx_rdy;				/*!< Receiver event queue. */
//    HANDLE ppp_tx_rdy;				/*!< Transmitter event queue. */
	HANDLE ppp_state_chg;				/*!< PPP State event queue */
    HANDLE ppp_tx_asy;					/*!< Asyncronous transmitter event queue. */
    NETBUF * volatile ppp_tx_nbq;		/*!< NETBUF queue. */
    u_long ppp_rx_packets;				/*!< Number of packets received. */
    u_long ppp_tx_packets;				/*!< Number of packets sent. */
//    u_long ppp_interrupts;			/*!< Number of interrupts. */
//    u_long ppp_overruns;				/*!< Number of packet overruns. */
//    u_long ppp_rx_frame_errors;		/*!< Number of frame errors. */
    u_long ppp_rx_crc_errors;			/*!< Number of CRC errors. */
//    u_long ppp_rx_missed_errors;		/*!< Number of missed packets. */
	u_char	ppp_lcp_id;
	u_short	ppp_mru;					
	u_long	ppp_accm;
	u_char	ppp_usePFC;
	u_char	ppp_useACFC;
	u_short	ppp_auth;
	u_long	ppp_magic;
	u_char	ppp_state;
	u_char	ppp_retry;
	HANDLE	ppp_tx_thread;
	HANDLE	ppp_rx_thread;

} PPPINFO;

// ppp_state bits all 0's = DEAD
#define	DEAD	0
#define	LINK_UP	1
#define	LCP_UP	2
#define	AUTH_UP	4
#define IPCP_UP	8
#define PPP_UP	0x0F		

typedef struct ppp_header {
	u_char	address;				//!< \brief HDLC Address. */
	u_char	control;				//!< \brief HDLC Control. */
	u_short	prot_type;				//!< \brief Protocol type. */
} PPPHDR;

typedef struct lcphdr 
{
    u_char	code;					//!< \brief LCP Code.                    
    u_char	id;						//!< \brief LCP Identifier
    u_short	len;					//!< \brief LCP Length
} LCPHDR;

typedef struct lcpopt 
{
    u_char	type;					//!< \brief LCP Option type.                    
    u_char	len;					//!< \brief LCP Option length
    u_char  *data;					//!< \brief LCP Option data
} LCPOPT;

/*
 * Definitions
 */
#define PPP_MRU			1500

#define PROT_PAP	    0xC023
#define PROT_LCP	    0xC021
#define PROT_IPCP       0x8021
#define PROT_IP         0x0021

//#define ICMP            0x01
//#define TCP             0x06

#define DEFAULT_TTL     64

#define HDLC_FLAG       0x7E
#define HDLC_ESCAPE     0x7D

#define	FCS_GOOD		0xF0B8

//#define PPP_Offset      5           // Number of bytes preceeding the PPP payload

//#define XCP_BadOpt      128         // Location in buffer to copy bad options to

#define XCP_CODE        0
#define XCP_ID          1
#define XCP_LEN_H       2
#define XCP_LEN_L       3
#define XCP_FIRST_OP    4

#define XCP_CR          1           // LCP/IPCP Configure-Request Code
#define XCP_CA          2           // LCP/IPCP Configure-Ack Code
#define XCP_CN          3           // LCP/IPCP Configure-Nack Code
#define XCP_CRJ         4           // LCP/IPCP Configure-Reject Code
#define XCP_TR          5           // LCP/IPCP Terminate-Request Code
#define XCP_TA          6           // LCP/IPCP Terminate-Ack Code
#define XCP_CDRJ        7           // LCP/IPCP Code-Reject Code
#define LCP_PRJ         8           // LCP Protocol-Reject Code
#define LCP_ERQ         9           // LCP Echo-Request Code
#define LCP_ERP         10          // LCP Echo-Response Code
#define LCP_DRQ         11          // LCP Discard-Request Code

#define LCP_MRU         1           // LCP MRU Option
#define LCP_ACCM        2           // LCP Async Control Map Option
#define LCP_AUTH        3           // LCP Authentication Protocol Option
#define LCP_QUAL        4           // LCP Quality Protocol Option
#define LCP_MAGIC       5           // LCP Magic Number Option
#define LCP_PFC         7           // LCP Protocol field compression Option
#define LCP_ACFC        8           // LCP Address/Control field compression Option

#define IPCP_ADDRESSES  1           // IPCP Ip Addresses Option (deprecated)
#define IPCP_COMPRESS   2           // IPCP Compression Option
#define IPCP_ADDRESS    3           // IPCP Ip Address Option
#define IPCP_PRI_DNS    0x81        // IPCP Primary DNS Address
#define IPCP_SEC_DNS    0x83        // IPCP Secondary DNS Address

#define PAP_REQ         1           // PAP Authenticate request
#define PAP_ACK         2           // PAP Accept
#define PAP_NACK        3           // PAP Reject


/*
 * Available drivers.
 */
extern NUTDEVICE devPPP0;
extern NUTDEVICE devPPP1;


/*
 * Driver routines.
 */
extern int PPPInit(NUTDEVICE *dev);
extern int PPPOutput(NUTDEVICE *dev, NETBUF *nb);
extern void PPPInput(NUTDEVICE *dev, NETBUF *nb);
extern int NutPPPOutput(NUTDEVICE *dev, u_short type, NETBUF *nb);
extern u_char PPPGetState (NUTDEVICE *dev);
//extern void PPPSetState (NUTDEVICE *dev, u_char state);
extern void PPPTerminateSesion (NUTDEVICE *dev);
extern void PPPLCPRequestOptions(NUTDEVICE *dev);
extern int CDNetPPPConnect (NUTDEVICE *dev, CONST char *scriptin);
#endif
