#include <stdlib.h>
#include <string.h>
#include <stdio.h>
#include <conio.h>
#include <errno.h>
#include <process.h>

int main(void)
{
    char *cp;
    char answ;
    char comp;
    char *mcu;
    char *isp;
    FILE *fp;
    char pathname[255];

    for(;;) {
        fputs("\nSelect a compiler:\n\n"
              "  1) GNU AVR-GCC\n"
              "  2) ImageCraft ICCAVR\n\n"
              "Selection -> "
              , stdout);
        comp = _getch();
        fprintf(stdout, "%c\n", comp);
        if(comp == '1' || comp == '2') 
            break;
    }

    if(comp == '1') {
        _searchenv("avr-gcc.exe", "PATH", pathname);
        if(pathname[0]) {
            fputs("\nCopying Makedefs.gcc to Makedefs", stdout);
            system("copy Makedefs.gcc Makedefs");
            fputs("Copying Makerules.gcc to Makerules", stdout);
            system("copy Makerules.gcc Makerules");
            fputs("Copying app\\Makedefs.gcc to app\\Makedefs", stdout);
            system("copy app\\Makedefs.gcc app\\Makedefs");
            fputs("Copying app\\Makerules.gcc to app\\Makerules", stdout);
            system("copy app\\Makerules.gcc app\\Makerules");
        }
    }
    else {
        _searchenv("iccavr.exe", "PATH", pathname);
        if(pathname[0]) {
            fputs("\nCopying Makedefs.icc to Makedefs", stdout);
            system("copy Makedefs.icc Makedefs");
            fputs("Copying Makerules.icc to Makerules", stdout);
            system("copy Makerules.icc Makerules");
            fputs("Copying app\\Makedefs.icc to app\\Makedefs", stdout);
            system("copy app\\Makedefs.icc app\\Makedefs");
            fputs("Copying app\\Makerules.icc to app\\Makerules", stdout);
            system("copy app\\Makerules.icc app\\Makerules");
        }
    }
    if(pathname[0] == 0) {
        fputs("\n\nCan't find the selected compiler. :-(\n\n"
              "This could mean either of the following:\n"
              "  1: You don't have the compiler installed.\n"
              "  2: You don't have your PATH environment variable set right.\n"
              "Here is your PATH variable:\n\n"
              , stderr);
        system("PATH");
        return 3;
    }

    for(;;) {
        fputs("\nSelect a target device:\n\n"
              "  1) ATmega128, red Ethernut board\n"
              "  2) ATmega103, green Ethernut board\n\n"
              "Selection -> "
              , stdout);
        answ = _getch();
        fprintf(stdout, "%c\n", answ);
        if(answ == '1') {
            mcu = (comp == '1') ? "atmega128" : "enhanced";
            break;
        }
        else if(answ == '2') {
            mcu = (comp == '1') ? "atmega103" : "mega";
            break;
        }
    }

    if(comp == '1') {
        for(;;) {
            fputs("\nWhich isp programmer are you using?\n\n"
                  "  1) Ethernut Starter Kit, STK200, STK300 or compatible\n"
                  "  2) STK500\n\n"
                  "Selection -> "
                  , stdout);
            answ = _getch();
            fprintf(stdout, "%c\n", answ);
            if(answ == '1') {
                isp = "stk200";
                break;
            }
            else if(answ == '2') {
                isp = "stk500";
                break;
            }
        }
    }
    else {
        char cmd[255];

        isp = "stk200";
        if((cp = strrchr(pathname, '\\')) != NULL)
            *cp = 0;
        fprintf(stdout, "\nCopying libraries to %s\\..\\lib:\n", pathname);
        sprintf(cmd, "copy lib\\icc\\%s\\*.a %s\\..\\lib", mcu, pathname);
        system(cmd);
    }

    if((fp = fopen("UserConf.mk", "w")) == NULL) {
        fprintf(stderr, "Writing UserConf.mk failed: %s\n", strerror(errno));
        return 3;
    }
    fprintf(fp, "MCU=%s\n", mcu);
    fprintf(fp, "UISP_PROG=%s\n", isp);
    fprintf(fp, "CRUROM=$(top_srcdir)\\tools\\win32\\crurom.exe\n");
    if(comp == '2') {
        cp = pathname;

        while(*cp) {
            if(*cp == '\\') 
                *cp = '/';
            cp++;
        }
        fprintf(fp, "AVR=%s/..\n", pathname);
    }
    fclose(fp);

    fprintf(stdout, "\nYour system is now configured to build Nut/OS for AVR %s.\n", mcu);
    fprintf(stdout, "Type `make clean` followed by 'make install' to rebuild the libraries.\n");
    if(comp == '2') {
        fprintf(stdout, "Copy all updated libraries from lib\\icc\\%s to the ICCAVR lib directory\n", mcu);
    }
    return 0;
}
